package vn.azteam.tpf.service.dto;

import java.io.Serializable;
import java.util.Objects;
import io.github.jhipster.service.filter.BooleanFilter;
import io.github.jhipster.service.filter.DoubleFilter;
import io.github.jhipster.service.filter.Filter;
import io.github.jhipster.service.filter.FloatFilter;
import io.github.jhipster.service.filter.IntegerFilter;
import io.github.jhipster.service.filter.LongFilter;
import io.github.jhipster.service.filter.StringFilter;

/**
 * Criteria class for the TBGuidelineActivity entity. This class is used in TBGuidelineActivityResource to
 * receive all the possible filtering options from the Http GET request parameters.
 * For example the following could be a valid requests:
 * <code> /tb-guideline-activities?id.greaterThan=5&amp;attr1.contains=something&amp;attr2.specified=false</code>
 * As Spring is unable to properly convert the types, unless specific {@link Filter} class are used, we need to use
 * fix type specific filters.
 */
public class TBGuidelineActivityCriteria implements Serializable {

    private static final long serialVersionUID = 1L;

    private LongFilter id;

    private LongFilter tbGuidelineDetailsId;

    private LongFilter tbActivityTypeId;

    private StringFilter externalTable;

    public LongFilter getId() {
        return id;
    }

    public void setId(LongFilter id) {
        this.id = id;
    }

    public LongFilter getTbGuidelineDetailsId() {
        return tbGuidelineDetailsId;
    }

    public void setTbGuidelineDetailsId(LongFilter tbGuidelineDetailsId) {
        this.tbGuidelineDetailsId = tbGuidelineDetailsId;
    }

    public LongFilter getTbActivityTypeId() {
        return tbActivityTypeId;
    }

    public void setTbActivityTypeId(LongFilter tbActivityTypeId) {
        this.tbActivityTypeId = tbActivityTypeId;
    }

    public StringFilter getExternalTable() {
        return externalTable;
    }

    public void setExternalTable(StringFilter externalTable) {
        this.externalTable = externalTable;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final TBGuidelineActivityCriteria that = (TBGuidelineActivityCriteria) o;
        return
            Objects.equals(id, that.id) &&
            Objects.equals(tbGuidelineDetailsId, that.tbGuidelineDetailsId) &&
            Objects.equals(tbActivityTypeId, that.tbActivityTypeId) &&
            Objects.equals(externalTable, that.externalTable);
    }

    @Override
    public int hashCode() {
        return Objects.hash(
        id,
        externalTable,
        tbGuidelineDetailsId,
        tbActivityTypeId
        );
    }

    @Override
    public String toString() {
        return "TBGuidelineActivityCriteria{" +
                (id != null ? "id=" + id + ", " : "") +
                (tbGuidelineDetailsId != null ? "tbGuidelineDetailsId=" + tbGuidelineDetailsId + ", " : "") +
                (tbActivityTypeId != null ? "tbActivityTypeId=" + tbActivityTypeId + ", " : "") +
                (externalTable != null ? "externalTable=" + externalTable + ", " : "") +
            "}";
    }

}
